/***************************************************************/
//
//
//		DirectX	[ fieldmap.cpp ]
//
//											Author	kazuki tanaka
//											Date	2017 5/29
/*---------------------------------------------------------------
Update : 2017/5/29
			fieldmap.cpp̍쐬
		   
		   2017/6/19 
		    t@Cǂݍŕ\@\ǉ
			t@C\
			(*.txt)
			vertical  
			horizonal
			X^[ǧ Shell̗񋓌^Q
			}bv\

			}bvdata/MAPɓĂ
			}bvLfieldmap.hTYPE񋓌^QƂĂ

/*---------------------------------------------------------------
	Include File
---------------------------------------------------------------*/

#include "system_component.h"

#include "fieldmap.h"

#include "gameobject.h"
#include "base.h"

#include "game_equation.h"

#include "castdx9.h"

#include <stdio.h>

#include "immortal.h"
#include "shell.h"
#include "octopus.h"
#include "start.h"
#include "keyboard.h"
/*---------------------------------------------------------------
	Macro Difinition
---------------------------------------------------------------*/
//tH_pX By
#define	MAPFOLDER_PATH	("data/MAP/")

/*---------------------------------------------------------------
	Const Number Difinition
---------------------------------------------------------------*/
//fATYPEɑΉ悤
const char* FieldMap::MODEL_NAME[TYPE_MAX] =
{
	"" , //NONE
	"data\\MODEL\\tablesango.x" , //IMMORTAL
	"data\\MODEL\\octupas.x" , //GOAL
	"data\\MODEL\\hotate.x" , //START 
	"data\\MODEL\\hotate.x" , //MOVE
};

/*----------------------------------------------------------------
	static member variable Initialize 
----------------------------------------------------------------*/

FieldMap* FieldMap::pMap = nullptr;




// FieldMap Constructor
FieldMap::FieldMap( )
	: pObj(nullptr)
	, map(nullptr)
	, vertical(0)
	, horizonal(0)
	, start(nullptr)
{

	// Menber Clear Process
	if( pMap ){
		delete pMap;
	}
	pMap = this;

	for( int i = 0 ; i < NUM_OBJECT ; i++ )
	{
		other[i] = nullptr;
	}
}

// FieldMap Destructor
FieldMap::~FieldMap( )
{

	// Do Nothing!!

}

// FieldMap Create Instance 
FieldMap* FieldMap::Create( void )
{

	// Create Class Instance
	return new FieldMap;

}

// FieldMap Initialize
void FieldMap::Init( const char* filename )
{

	// Initialize Process
	if( !pMap ){
		return;
	}
	

	//t@Cǂݍ݋@\ǉ@by
	FILE	*fp = NULL ;	//t@Cp

	char mappath[256] = MAPFOLDER_PATH;
	strcat( mappath , filename );

	//ǂݍ߂`FbN
	if ((fp = fopen( mappath , "r")) == NULL)
	{
		//s
		char	message[100] = "}bvt@Cǂݍ߂܂ : ";
		strcat(message , mappath );
		MessageBox( NULL , message , "ERROR[ fieldmap.cpp ]" , MB_OK | MB_ICONEXCLAMATION );
	}

	char h[16];
	fscanf(fp , "%s" , h );		
	char v[16];
	fscanf(fp , "%s" , v );
	

	vertical  = atoi(h);
	horizonal = atoi(v);
	
	char d[16];
	fscanf(fp , "%s" , d );
	int direction = atoi(d);
	
	const int size = MAP_SIZE;
	Vector2 offset( -(size*pMap->vertical)*0.5f  , size*pMap->horizonal*0.5f  );
	Vector2 objOffset( -(size*pMap->vertical)*0.5f + size * 0.5f  , size*pMap->horizonal*0.5f - size*0.5f );


	map  = new int[(vertical)*(horizonal)];
	pObj = new GameObject*[ vertical*horizonal ];

	int otherCounter = 0;
	
	CConsole::DebugLog( "txt data \n");
	fgetc(fp);

	for(int z = 0; z < pMap->horizonal; z++ ){
		for(int x = 0; x < pMap->vertical; x++ ){
			
			char c = fgetc(fp);
			int  fleld = atoi(&c);

			CConsole::DebugLog(" %d", fleld );


			//t@CLō쐬IuWFNgύX
			//VIuWFNgꍇ́AɒǉĂ
			switch	(fleld){
			case IMMORTAL:
				other[ otherCounter ] = Model::Create<Immortal>( MODEL_NAME[ IMMORTAL ] , Vector3( objOffset.x+size*x  ,0,objOffset.y - size * z ), Vector3(0,0,0), Vector3(0.1,0.1,0.1));
				other[otherCounter]->Init();
				otherCounter++;
				break;

			case GOAL:
				other[ otherCounter ] = Model::Create<Octopus>( MODEL_NAME[ GOAL ] ,  Vector3( objOffset.x+size*x  ,0,objOffset.y - size * z ), Vector3(0,0,0),Vector3( 0.2 , 0.2 , 0.2 ));
				other[otherCounter]->Init();
				otherCounter++;
				break;

			case START:
				other[ otherCounter ]  = Model::Create<Start>( MODEL_NAME[ START ] , Vector3( objOffset.x+size*x  ,0,objOffset.y - size * z ), Vector3(0,0,0));
				start = other[otherCounter];
				dynamic_cast<Shell*>(other[otherCounter])->SetDirection( direction );
				other[otherCounter]->Init();
				otherCounter++;
				break;

			case 4:
				other[ otherCounter ]= Model::Create<Shell>( MODEL_NAME[ MOVE ] , Vector3( objOffset.x+size*x  ,0,objOffset.y - size * z ), Vector3(0,0,0));
				other[otherCounter]->Init();
				dynamic_cast<Shell*>(other[otherCounter])->SetDirection( Shell::DIR_UP );
				otherCounter++;
				break;

			case 5:
				other[ otherCounter ]= Model::Create<Shell>( MODEL_NAME[ MOVE ] , Vector3( objOffset.x+size*x  ,0,objOffset.y - size * z ), Vector3(0,0,0));
				other[otherCounter]->Init();
				dynamic_cast<Shell*>(other[otherCounter])->SetDirection( Shell::DIR_LEFT );
				otherCounter++;		
				break;

			case 6:
				other[ otherCounter ]= Model::Create<Shell>( MODEL_NAME[ MOVE ] , Vector3( objOffset.x+size*x  ,0,objOffset.y - size * z ), Vector3(0,0,0));
				other[otherCounter]->Init();
				dynamic_cast<Shell*>(other[otherCounter])->SetDirection( Shell::DIR_DOWN );
				otherCounter++;
				break;

			case 7:
				other[ otherCounter ]= Model::Create<Shell>( MODEL_NAME[ MOVE ] , Vector3( objOffset.x+size*x  ,0,objOffset.y - size * z ), Vector3(0,0,0));
				other[otherCounter]->Init();
				dynamic_cast<Shell*>(other[otherCounter])->SetDirection( Shell::DIR_RIGHT );
				otherCounter++;
				break;

			default:
				CConsole::DebugLog( "Error[%d] ",fleld);
				break;
			};

			CConsole::DebugLog("\n");

			
		}
		fgetc(fp);
	}

	fclose(fp);

	GridVertex* pVtx;

	// Create Vertex Process
	if( FAILED( GetDevice()->CreateVertexBuffer(
		sizeof( GridVertex ) * (((horizonal+1)+(vertical+1)))*2,		// mۂobt@TCY(_m) P:oCg
			D3DUSAGE_WRITEONLY,								// gp@
			GRID_FVF_FORMAT,								// gp钸_tH[}bg
			D3DPOOL_MANAGED,								// obt@̊Ǘ@
			&pVtxBuf,										// i[|C^
			NULL )))
	{
		#ifdef _DEBUG
		MessageBox( NULL, "obt@ւ݂̏Ɏs܂!!" , " DRAWLOGO VTXBUF ERROR !!" , MB_OK );
		#endif	// _DEBUG

		return;
	}

	pVtxBuf -> Lock(0,0,(void**)&pVtx,0);		

	int index = 0;
	for( int z = 0; z < horizonal+1; z++ ){

		pVtx[index++].pos = D3DXVECTOR3( offset.x, 0,offset.y-size*z );
		pVtx[index].color = D3DXCOLOR(0.3, 1.0, 0.3, 1.0 );

		pVtx[index++].pos = D3DXVECTOR3( -offset.x,0,offset.y-size*z );
		pVtx[index].color = D3DXCOLOR(0.3, 1.0, 0.3, 1.0 );
	}

	for( int x = 0; x < vertical+1; x++  ){
			
		pVtx[index++].pos = D3DXVECTOR3( offset.x+size*x,0,offset.y );
		pVtx[index].color = D3DXCOLOR(0.3, 1.0, 0.3, 1.0 );

		pVtx[index++].pos = D3DXVECTOR3( offset.x+size*x,0,-offset.y );
		pVtx[index].color = D3DXCOLOR(0.3, 1.0, 0.3, 1.0 );
	}

	pVtxBuf ->Unlock();

}

// FieldMap Uninitialize
void FieldMap::Uninit( void )
{

	// Uninitialize Process
	SAFE_DELETE_ARRAY(map)
	delete pMap;

}

// FieldMap Update
void FieldMap::Update( void )
{
	// Update Process
	if( !pMap )
		return;

	// Update Process
	for(int z = 0; z < pMap->horizonal; z++ ){
		for(int x = 0; x < pMap->vertical; x++ ){
			map[z*(vertical) + x]  = NONE;
			pObj[z*(vertical) + x] = nullptr;
		}
	}

	for( int index = 0; index < NUM_OBJECT; index++ ){
		if( other[index] != NULL )
			other[index]->Update();
	}

	if( CInputKeyboard::Access()->GetKeyTrigger(DIK_RETURN) )
		dynamic_cast<Start*>(start)->GameStart();

}

// FieldMap Draw
void FieldMap::Draw( void )
{

	// Draw Process
	if( !pMap )
		return;

	Matrix mat;

	mat = mat.Identity();

	GetDevice()->SetTransform( D3DTS_WORLD, &CastMtx(mat) );

	// Xg[
	GetDevice()->SetStreamSource(0,					
		pVtxBuf,								
		0,													
		sizeof( GridVertex ));						

	// _tH[}bg̐ݒ
	GetDevice()->SetFVF( GRID_FVF_FORMAT );

	// Draw Process
	GetDevice()->DrawPrimitive( D3DPT_LINELIST, 0, ((horizonal+1)+(vertical+1)) );
	
	for( int index = 0; index < NUM_OBJECT; index++ ){
		if( other[index] != NULL )
			other[index]->Draw();
	}
	int i = 0;
}

// FieldMap
void FieldMap::SetObject( Vector3 pos, TYPE type, GameObject* pObj )
{

	const int size = MAP_SIZE;
	Vector2 start( -(size*pMap->vertical)*0.5f, size*pMap->horizonal*0.5f );
	for(int z = 0; z < pMap->horizonal; z++ ){
		for(int x = 0; x < pMap->vertical; x++ ){

			Vector3 current = Vector3( start.x + size*x, 0, start.y - size*z );
			Vector3 next = Vector3( start.x + size*(x+1), 0, start.y - size*(z+1));

			Vector3 center = current + (next - current)*0.5f;

			//if( __CollisionObjectSquare<Vector3>( current, next, pos, size*0.5f ) ){
			if( __CollisionObjectSphere( &CastVec3(center), &CastVec3(pos), size*0.5f, size*0.5f )){
				if( !pMap->map[z*(pMap->vertical)+x] ){
					pMap->map[z*(pMap->vertical)+x]  = type;
					pMap->pObj[z*(pMap->vertical)+x] = pObj;
					CConsole::DebugLog(" object[%p] x:%d, z:%d \n",pObj, z, x );
					break;
				}else{
			
					pObj->pos = dynamic_cast<Base*>(pObj)->prev;
					SetObject( pObj->pos, type, pObj );
					break;
				}
			}
		}
	}

}

// FieldMap
void FieldMap::FieldCheck( void )
{


	CDebugFont::Access()->SetRenderData( R_RENDER ,"map data \n");

	for(int z = 0; z < pMap->horizonal; z++ ){
		for(int x = 0; x < pMap->vertical; x++ ){

			CDebugFont::Access()->SetRenderData( R_RENDER ," %d", map[z*pMap->vertical+x]);

			if( map[z*pMap->vertical+x] != NONE ){
				switch( map[z*(pMap->vertical)+x] )
				{
				case IMMORTAL:
					break;
				case MOVE:
					OnScissor( z, x );
					Scissor( z, x );
					break;
				case GOAL:
					OnScissor( z, x );
					break;
				default:
					break;
				}
			}
		}
		CDebugFont::Access()->SetRenderData( R_RENDER ,"\n");
	}

}

// FieldMap
int* FieldMap::GetStatus( void )
{

	return pMap->map;

}

// FieldMap
bool FieldMap::Scissor( const int& z, const int& x )
{

	if( x <= 1 || z <= 1 || x >= (vertical+1) || z >= (horizonal+1) ){
		return false;
	}

	if( map[z*(pMap->vertical)+x] != NONE && map[z*(pMap->vertical)+x-1] != NONE && map[z*(pMap->vertical)+x-2] != NONE ){
		if( pObj[z*(pMap->vertical)+x] )
			dynamic_cast<Base*>(pObj[z*(pMap->vertical)+x])->Scissor();
		return true;
	}
	if( map[z*(pMap->vertical)+x] != NONE && map[z*(pMap->vertical)+x+1] != NONE && map[z*(pMap->vertical)+x+2] != NONE ){
		if( pObj[z*(pMap->vertical)+x] )
			dynamic_cast<Base*>(pObj[(z)*(pMap->vertical)+x])->Scissor();
		return true;
	}
	if( map[z*(pMap->vertical)+x] != NONE && map[(z-1)*(pMap->vertical)+x] != NONE && map[(z-2)*(pMap->vertical)+x] != NONE ){
		if( pObj[z*(pMap->vertical)+x] )
			dynamic_cast<Base*>(pObj[(z)*(pMap->vertical)+x])->Scissor();
		return true;
	}
	if( map[z*(pMap->vertical)+x] != NONE && map[(z+1)*(pMap->vertical)+x] != NONE && map[(z+2)*(pMap->vertical)+x] != NONE ){
		if( pObj[z*(pMap->vertical)+x] )
			dynamic_cast<Base*>(pObj[(z)*(pMap->vertical)+x])->Scissor();
		return true;
	}

	return false;

}

// FieldMap
bool FieldMap::OnScissor( const int& z, const int& x )
{


	if( map[z*(pMap->vertical)+x+1] != NONE && map[z*(pMap->vertical)+x-1] != NONE ){
		dynamic_cast<Base*>(pObj[z*(pMap->vertical)+x])->OnScissor();

		
		if( z == 5 && x == 4 ){
			int i = 0;
		}

		return true;

	}
	if( map[(z+1)*(pMap->vertical)+x] != NONE && map[(z-1)*(pMap->vertical)+x] != NONE ){
		dynamic_cast<Base*>(pObj[z*(pMap->vertical)+x])->OnScissor();
		

		
		if( z == 5 && x == 4 ){
			int i = 0;
		}
		return true;
	}

	return false;


}






