/***************************************************************/
//
//
//		DirectX	[ gameobject.h ]
//
//											Author	kazuki tanaka
//											Date	2017 6/5
/*---------------------------------------------------------------
Update : 2017/6/5
			Create Header File -> gameobject.h.h 
 			< Add Class Function >
				GAMEOBJECT->Constructor
				GAMEOBJECT->Destructor
				GAMEOBJECT->Create ( static member )
				GAMEOBJECT->Init
				GAMEOBJECT->Uninit
				GAMEOBJECT->Update
				GAMEOBJECT->Draw

Update : 2017/6/5



/*-------------------------------------------------------------*/
#ifndef _GAMEOBJECT_H_

#define _GAMEOBJECT_H_


/*---------------------------------------------------------------
	Include File
---------------------------------------------------------------*/

#include "matrix.h"
#include "vector3.h"

class GameComponent;

#include <vector>

/*---------------------------------------------------------------
	Class
---------------------------------------------------------------*/


// Class GameObject Using GameObject
class GameObject
{
public:
	
	GameObject( );									// GameObject Constructor
	~GameObject( );									// GameObject Destructor

	static GameObject* Create( void );				// GameObject Create Instance Class

	virtual void Init( void );						// GameObject Initialize
	virtual void Uninit( void );					// GameObject Uninitialize
	virtual void Update( void );					// GameObject Update
	virtual void Draw( void );						// GameObject Draw
	
	virtual void OnContact( void );					// GameObject OnContact]

	Matrix GetMatrix( void );						// GameObject GetMatrix
	void SetParent( GameObject* pObject );			// GameObject SetParent

	template<class X>GameComponent* GetComponent()	// GameObject GetComponent<X>
	{	
		return new X;
	}

	template<class X>void AddComponent()			// GameObject AddComponent<X>
	{
		pBehaviour.push_back( new X );
	}

protected:

	void ParentageProcess( void );					// GameObject Ref Parentage

protected:
public:

	// Member Variable
	Matrix world;
	GameObject* parent;
	Vector3 pos;
	Vector3 rot;
	Vector3 scale;
	std::vector<GameComponent*> pBehaviour;


};


#endif	//	_GAMEOBJECT_H_




