/***************************************************************/
//
//
//		DirectX	[ title.h ]
//
//											Author	kazuki tanaka
//											Date	2017 6/14
/*---------------------------------------------------------------
Update : 2017/6/14
			Create Header File -> title.h.h 
 			< Add Class Function >
				CTITLE->Constructor
				CTITLE->Destructor
				CTITLE->Create ( static member )
				CTITLE->Init
				CTITLE->Uninit
				CTITLE->Update
				CTITLE->Draw

Update : 2017/6/14



/*-------------------------------------------------------------*/
#ifndef _TITLE_H_

#define _TITLE_H_

#include "scene.h"
#include "k_title.h"
#include "camera.h"
#include "k_light.h"

/*---------------------------------------------------------------
	Class
---------------------------------------------------------------*/


// Class CTitle Using Title
class CTitle : public Scene
{
public:
	CTitle( );							// CTitle Constructor
	~CTitle( );						// CTitle Destructor

	static CTitle* Create( void );	// CTitle Create Instance Class

	void Init( void );				// CTitle Initialize
	void Uninit( void );			// CTitle Uninitialize
	void Update( void );			// CTitle Update
	void Draw( void );				// CTitle Draw



private:

	// Member Variable
	CCamera* camera;
	KLight* light;
	KTitle* title;


};


#endif	//	_TITLE_H_


