/***************************************************************/
//
//
//		DirectX	[ virtual.cpp ]
//
//											Author	kazuki tanaka
//											Date	2017 5/25
/*---------------------------------------------------------------
Update : 2017/5/25
			virtual.cpp̍쐬

/*---------------------------------------------------------------
	Include File
---------------------------------------------------------------*/



#include "virtual.h"

#include "light.h"
#include "photo.h"

#include "meshfield.h"
#include "fieldmap.h"

#include "rendering_orderdx9.h"

#include "immortal.h"
#include "shell.h"
#include "start.h"

#include <time.h>

#include "particle.h"
#include "explosion.h"

#include "castdx9.h"
#include "game_equation.h"

#include "keyboard.h"

/*---------------------------------------------------------------
	Macro Difinition
---------------------------------------------------------------*/


/*---------------------------------------------------------------
	Const Number Difinition
---------------------------------------------------------------*/


/*----------------------------------------------------------------
	static member variable Initialize 
----------------------------------------------------------------*/





// CVirtual Constructor
CVirtual::CVirtual( )
	: meshField(nullptr)
	, map(nullptr)
	, obj(nullptr)
{

	// Member Clear Process


}

// CVirtual Destructor
CVirtual::~CVirtual( )
{

	// Do Nothing!!

}

// CVirtual Create Instance 
CVirtual* CVirtual::Create( void )
{

	// Create Class Instance
	CVirtual* pObject;
	pObject = new CVirtual;

	return pObject;

}

// CVirtual Initialize
void CVirtual::Init( void )
{

	// Initialize Process
	meshField = MeshField::Create( );
	meshField->Init( );

	map = FieldMap::Create( );
	map->Init( "text.txt" );

	CPhoto::Create( "mainCamera" )->Init( );
	CLight::Create( "Directional" );

	/*
	obj = Model::Create<Immortal>( "data\\MODEL\\octupas.x", Vector3(0,0,0), Vector3(0,0,0), Vector3(0.1,0.1,0.1));
	obj->Init();
	*/
	InitParticle();
	InitExplosion();

	srand( (unsigned int)time(NULL));
	
	for( int index = 0; index < 2; index++ ){
		if( index == 0 ){
			other[index] = Model::Create<Start>( "data\\MODEL\\hotate.x", Vector3(50,0,0), Vector3(0,0,0));
			dynamic_cast<Shell*>(other[index])->SetDirection( Shell::DIR_RIGHT );
		}if( index == 1 ){	
			other[index] = Model::Create<Shell>( "data\\MODEL\\hotate.x", Vector3(-50,0,0), Vector3(0,0,0));
			dynamic_cast<Shell*>(other[index])->SetDirection( Shell::DIR_LEFT );
		}else{
			//other[index] = Model::Create<Shell>( "data\\MODEL\\move.x", Vector3(50-rand()%100,0,50-rand()%100), Vector3(0,0,0));
			//dynamic_cast<Shell*>(other[index])->SetDirection( rand()%4 );
		}
		other[index]->Init();
	}

	//SetExplosion( &D3DXVECTOR3(0,0,0) );



}

// CVirtual Uninitialize
void CVirtual::Uninit( void )
{

	// Uninitialize Process
	meshField->Uninit( );

	map->Uninit();
	/*
	obj->Uninit();

	for( int index = 0; index < 2; index++ ){
		other[index]->Uninit();
	}*/

	UninitParticle();
	UninitExplosion();

	CPhoto::ReleaseAll( );
	CLight::ReleaseAll( );


}

// CVirtual Update
void CVirtual::Update( void )
{

	// Update Process
	meshField->Update( );

	map->Update();
	/*
	obj->Update();
	*/
	/*
	for( int index = 0; index < 2; index++ ){
		other[index]->Update();
	}

	if( CInputKeyboard::Access()->GetKeyTrigger(DIK_RETURN) ){
		dynamic_cast<Start*>(other[0])->GameStart();
	}*/

	UpdateParticle();
	UpdateExplosion();

	static int flame = 0;
	if( flame % MAP_SIZE == 0 )
	map->FieldCheck();


	//Vector3 pos = pObj->Getpos( );
	//pos.y = meshField->GetHeight( pos );
	//pObj->Setpos( pos );

}

// CVirtual Draw
void CVirtual::Draw( void )
{

	// Draw Process
	CPhoto::Access( "mainCamera" )->SetPhoto( );

	//meshField->Draw();

	map->Draw( );
	//obj->Draw();

	/*
	for( int index = 0; index < 2; index++ ){
		other[index]->Draw();
	}*/

	DrawParticle();

}





